/*********************************************************************
**  MCU:STC11F32XE LQFP-44
**  18.432M
**  1
**  
*********************************************************************/

#include "include.h"

unsigned char idata LastKeyA[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};//NO.2
unsigned char idata NewKeyA[6]={0x19,0x84,0x07,0x15,0x76,0x14};//NO.2
unsigned char idata NewKey[16]={0x19,0x84,0x07,0x15,0x76,0x14,
				0xff,0x07,0x80,0x69,
				0x19,0x84,0x07,0x15,0x76,0x14};

unsigned char idata Read_Data[16]={0x00};
unsigned char idata Write_First_Data[16];
unsigned char idata Write_Consume_Data[16];
unsigned char idata RevBuffer[30];
unsigned char idata MLastSelectedSnr[4];
unsigned char data oprationcard;

uint data KeyNum;
uint data TimeShowMenu;
uchar data bShowMenu,bShowWelcome,bWarn,bPass;
uchar data SysTime,KeyTime;
uchar data bTimed;
uchar data bMenued;

extern char PcdReset(void);
extern char PcdRequest(unsigned char data req_code,unsigned char *pTagType);
extern void PcdAntennaOn(void);
extern void PcdAntennaOff(void);
extern char M500PcdConfigISOType(unsigned char data type);
extern char PcdAnticoll(unsigned char *pSnr);
extern char PcdSelect(unsigned char *pSnr);
extern char PcdAuthState(unsigned char data auth_mode,unsigned char data addr,unsigned char *pKey,unsigned char *pSnr);
extern char PcdWrite(unsigned char data addr,unsigned char *pData);
extern char PcdRead(unsigned char data addr,unsigned char *pData);
extern char PcdHalt(void);

extern void InitLcd0108(void); //ʼLCD
extern void ShowHZ1616(unsigned char data lin,unsigned char data column,unsigned int data address);
extern void Show816(unsigned char data lin,unsigned char data column,unsigned int data address);
extern void ShowHZ3232(unsigned char data lin,unsigned char data column,unsigned int data address);
extern void ShowFloat816(unsigned char data lin,unsigned char data column,float data flt);
extern void Clear88(uchar data lin,uchar data column,uchar data lin_x,uchar data column_y);
extern void ShowMenu(void);
extern void ShowWelcome(void); 
extern void ShowTime(void);
extern void ShowBCD4(unsigned char data lin,unsigned char data column,uint data udata);
extern void ShowBCD2(unsigned char data lin,unsigned char data column,uchar data value);
extern void ShowReverse816(unsigned char data lin,unsigned char data column,uchar data ucode);


extern uchar GetKey(void);

void delay_ms(uint data tms)
{
  uint data ii;
  while(tms)
  {
    tms--;
    for(ii=0;ii<400;ii++)
    {
      nop();nop();nop();nop();nop();nop();
    }
  }
}

void Dlms(uchar data tm)
{
  uchar data ii;
  while(tm--)
  {
    for(ii=0;ii<100;ii++);
  }
}

void InitPort(void)
{
  P0M1=0x00;
  P0M0=0xff;
  
  P1M1=0x00;
  P1M0=0x00;
  
  P24=1;
  P2M1=0x10;
  P2M0=0x88;
  
  P30=1;
  P36=1;
  P3M1=0x41;
  P3M0=0xa2;
  
  P41=1;
  P4M1=0x02;
  P4M0=0x04;
  
  CLR_BEEP;
}


/**********************************************************************
functionName:putChar(BYTE sentData)
description:ͨڷsentData
**********************************************************************/
void sendchar1(uchar data sentData)
{
  ES=0;
  TI=0;
  SBUF=sentData;
  while(TI==0);
  TI=0;
  ES=1;
}

//UART0 initialize
// desired baud rate: 9600
// actual: baud rate:9600 (0.0%)
// char size: 8 bit
// parity: Disabled
void uart_init(void)
{
  SCON = 0x50;
  BRT=RELOAD_COUNT;
  AUXR=0x11;
  AUXR1=0x00;  //0x80:p1  0x00:p3
  ES=1;
}

void uart_interrupt_receive(void) interrupt 4
{
//  uchar data R_Char;
  //SEI();
  if(RI==1);
  {
    RI=0;
    /*R_Char=SBUF;
    RevBuffer[uart_count]=R_Char;
    uart_count++;
    if(uart_count==RevBuffer[0])
    {
      uart_comp=1;
    }*/ 
  } 
}

void InitRc522(void)
{
  PcdReset();
  PcdAntennaOff();  
  PcdAntennaOn();
  M500PcdConfigISOType( 'A' );
}

//TIMER1 initialize - prescale:8
// desired value: 20mSec
// actual value: 19.999mSec (0.0%)
void init_time0(void)  //25ms
{
  TMOD=0x01;
  TH0=0x69;
  TL0=0xfe;
  ET0=1;
  TR0=1;
}

void  time0_routine(void) interrupt 1
{
  //TIMER1 has overflowed
  TMOD=0x01;
  TH0=0x69;
  TL0=0xfe;
  SysTime++;
  if(TimeShowMenu<250)
  {
    TimeShowMenu++;
    if(TimeShowMenu>=250)
    {
      bShowWelcome=1;
      bShowMenu=0;
    }
  }
  if(KeyTime)
  {
    KeyTime--;
  }
}

void InitAll(void)
{
  Dlms(100);
  InitPort();
  Dlms(100);
  InitLcd0108();
  InitRc522();
  EA=0;
  init_time0();
  uart_init();
  EA=1; //re-enable interrupts  
  TimeShowMenu=0;
  bShowMenu=0;
//  bShowTime=1;
  bWarn=0;
  bPass=0;
  SysTime=0;
  KeyTime=0;
  KeyNum=0;
  bTimed=1;
  bMenued=0; 
  bShowWelcome=1; 
  TimeShowMenu=250;
}

void ctrlprocess(void)
{
  signed long money_value;
  float f_money_value;
  unsigned char ii;
  char status;
  status=PcdRequest(PICC_REQIDL,&RevBuffer[0]);//Ѱδ״̬ĿؿƬ 2ֽ
  if(status!=MI_OK)
  {
    return;
  }
  status=PcdAnticoll(&RevBuffer[2]);//ײؿк 4ֽ
  if(status!=MI_OK)
  {
    return;
  }
  if(!bShowMenu)
  {
    bShowMenu=1;
    //bShowWelcome=0;
      bTimed=0;
      bMenued=1;    
    ShowMenu();
  }
  TimeShowMenu=0;
  //Clear88(0,5,2,8);
  Clear88(2,5,2,8);
  Clear88(4,5,2,8);
  //Clear88(6,5,2,8);
  memcpy(MLastSelectedSnr,&RevBuffer[2],4);
  for(ii=0;ii<4;ii++)
  {
    Show816(0,5+2*ii,(MLastSelectedSnr[ii]>>4)&0x0f);
    Show816(0,6+2*ii,MLastSelectedSnr[ii]&0x0f);
  } 
  status=PcdSelect(MLastSelectedSnr);//ѡ
  if(status!=MI_OK)
  {
    return;
  }
  if(oprationcard==REGCARD)//ע
  {
    status=PcdAuthState(PICC_AUTHENT1A,7,LastKeyA,MLastSelectedSnr);//
    //DelayNS(1);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }
    status=PcdWrite(7,&NewKey[0]);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }
    for(ii=0;ii<16;ii++)
    {
      Write_First_Data[ii]=0xaa;
    }
	memset( Write_First_Data, 0, sizeof(Write_First_Data) );
	money_value = 5000;
	memcpy( Write_First_Data, ( uchar * )&money_value, 4 );
    status=PcdWrite(4,&Write_First_Data[0]);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }
    bPass=1;						
    PcdHalt();		
  }
  else if(oprationcard==READCARD)//
  {
    status=PcdAuthState(PICC_AUTHENT1A,7,NewKeyA,MLastSelectedSnr);//????KUAI4?
    if(status!=MI_OK)
    {
      return;
    }
    status=PcdRead(4,Read_Data);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }
	memcpy( (uchar *)&money_value, Read_Data, 4 );

	f_money_value = money_value * 1.0;
			
    ShowFloat816( 4, 5, ( f_money_value >= 0 ) ? ( ( f_money_value+0.5 )/100 ) : ( ( f_money_value-0.5 )/100 ) ); 
    if(f_money_value<0)
    {
      bWarn=1;
    }  
    bPass=1;
    PcdHalt();	
  }
  else if(oprationcard==CONSUME)//
  {
    status=PcdAuthState(PICC_AUTHENT1A,7,NewKeyA,MLastSelectedSnr);//
    if(status!=MI_OK)
    {
      return;
    }
    status=PcdRead(4,Read_Data);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }
    memcpy( (uchar *)&money_value, Read_Data, 4 );
    if(money_value<-10000)
    {
      money_value=-10000;
    }
    if(money_value<0)
    {
      money_value+=10000;
    }
    money_value=money_value-258;

	memcpy( Write_Consume_Data, (uchar *)&money_value, 4 );
    status=PcdWrite(4,&Write_Consume_Data[0]);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }		
    ShowFloat816(2,5,2.58);

	f_money_value = money_value * 1.0;

    ShowFloat816(4,5,( f_money_value >= 0 ) ? ( ( f_money_value+0.5 )/100 ) : ( ( f_money_value-0.5 )/100 )); 
    if(money_value<0)
    {
      bWarn=1;
    }  
    else
    { 
      bPass=1;
    }
    PcdHalt();	
  }
  else if(oprationcard==ADDMONEY)//ֵ
  {
    status=PcdAuthState(PICC_AUTHENT1A,7,NewKeyA,MLastSelectedSnr);//????KUAI4?
    if(status!=MI_OK)
    {
      return;
    }
    status=PcdRead(4,Read_Data);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }

	memcpy( (uchar *)&money_value, Read_Data, 4 );
    if(money_value<-10000)
    {
      money_value=-10000;
    }
    if(money_value<0)
    {
      money_value+=10000;
    }
    money_value=money_value+5000;

	memcpy( Write_Consume_Data, (uchar *)&money_value, 4 );
    status=PcdWrite(4,&Write_Consume_Data[0]);
    if(status!=MI_OK)
    {
      bWarn=1;
      return;
    }		
    ShowFloat816(2,5,50.00);

	f_money_value = money_value * 1.0;

    ShowFloat816(4,5,( f_money_value >= 0 ) ? ( ( f_money_value+0.5 )/100 ) : ( ( f_money_value-0.5 )/100 )); 
    bPass=1;
    PcdHalt();	
  }  					
}

void Warn(void)
{
  uchar data ii;
  for(ii=0;ii<3;ii++)
  {
    SET_BEEP;
    delay_ms(120);
    CLR_BEEP;
    delay_ms(120);
  }
}

void Pass(void)
{
  SET_BEEP;
  delay_ms(700);
  CLR_BEEP;
}

void main(void)
{
  InitAll();
  oprationcard=CONSUME;
  while(1)
  {
    KeyNum=GetKey();
    if(bMenued)
   {
    if( (KeyNum==N_1)&&(!KeyTime) )
    {
      KeyTime=15;
      TimeShowMenu=0;
      oprationcard=CONSUME;
      sendchar1(KeyNum);
      ShowHZ1616(2,0,4); //  
      ShowHZ1616(2,2,5); //        
    }
    else if( (KeyNum==N_2)&&(!KeyTime) )
    {
      KeyTime=15;
      TimeShowMenu=0;
      oprationcard=ADDMONEY;
      sendchar1(KeyNum);
      ShowHZ1616(2,0,6); //ֵ 
      ShowHZ1616(2,2,7); //       
    }
    else if( (KeyNum==N_3)&&(!KeyTime) )
    {
      KeyTime=15;
      TimeShowMenu=0;
      oprationcard=REGCARD;
      sendchar1(KeyNum);
      ShowHZ1616(2,0,10); //ע 
      ShowHZ1616(2,2,11); //       
    } 
    else if( (KeyNum==N_4)&&(!KeyTime) )
    {
      KeyTime=15;
      TimeShowMenu=0;
      oprationcard=READCARD;
      sendchar1(KeyNum);
      ShowHZ1616(2,0,12); //
      ShowHZ1616(2,2,13); //       
    }  
   
   }      
    if(bShowWelcome)
    {
      bShowWelcome=0;
      bTimed=1;
      bMenued=0;
      ShowWelcome();  
    }
    if(bWarn)
    {
      bWarn=0;
      Warn();
    }
    if(bPass)
    {
      bPass=0;
      Pass();
    }
    ctrlprocess();
  }  
}